diff --git a/tests/qemu-iotests/146 b/tests/qemu-iotests/146
new file mode 100755
index 0000000..af60849
--- /dev/null
+++ b/tests/qemu-iotests/146
@@ -0,0 +1,119 @@
+#!/bin/bash
+#
+# Test VHD image format creator detection and override
+#
+# Copyright (C) 2016 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+# creator
+owner=jcody@redhat.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+status=1    # failure is the default!
+
+_cleanup()
+{
+    _cleanup_qemu
+    _cleanup_test_img
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+. ./common.qemu
+
+_supported_fmt vpc
+_supported_proto file
+_supported_os Linux
+
+
+qemu_comm_method="monitor"
+silent=
+
+echo
+echo === Testing VPC Autodetect ===
+echo
+_use_sample_img virtualpc-dynamic.vhd.bz2
+
+_launch_qemu -drive file="${TEST_IMG}",id=disk,format=vpc
+h1=$QEMU_HANDLE
+
+_send_qemu_cmd $h1 'qemu-io disk "map"' "sectors"
+_send_qemu_cmd $h1 'quit' ""
+
+echo
+echo === Testing VPC with current_size force ===
+echo
+
+_launch_qemu -drive file="${TEST_IMG}",id=disk,format=vpc,force_size_calc=current_size
+h1=$QEMU_HANDLE
+
+_send_qemu_cmd $h1 'qemu-io disk "map"' "sectors"
+_send_qemu_cmd $h1 'quit' ""
+
+echo
+echo === Testing VPC with chs force ===
+echo
+
+_launch_qemu -drive file="${TEST_IMG}",id=disk,format=vpc,force_size_calc=chs
+h1=$QEMU_HANDLE
+
+_send_qemu_cmd $h1 'qemu-io disk "map"' "sectors"
+_send_qemu_cmd $h1 'quit' ""
+
+
+_cleanup_test_img
+
+echo
+echo === Testing Hyper-V Autodetect ===
+echo
+_use_sample_img hyperv2012r2-dynamic.vhd.bz2
+
+_launch_qemu -drive file="${TEST_IMG}",id=disk,format=vpc
+h1=$QEMU_HANDLE
+
+_send_qemu_cmd $h1 'qemu-io disk "map"' "sectors"
+_send_qemu_cmd $h1 'quit' ""
+
+echo
+echo === Testing Hyper-V with current_size force ===
+echo
+
+_launch_qemu -drive file="${TEST_IMG}",id=disk,format=vpc,force_size_calc=current_size
+h1=$QEMU_HANDLE
+
+_send_qemu_cmd $h1 'qemu-io disk "map"' "sectors"
+_send_qemu_cmd $h1 'quit' ""
+
+echo
+echo === Testing Hyper-V with chs force ===
+echo
+
+_launch_qemu -drive file="${TEST_IMG}",id=disk,format=vpc,force_size_calc=chs
+h1=$QEMU_HANDLE
+
+_send_qemu_cmd $h1 'qemu-io disk "map"' "sectors"
+_send_qemu_cmd $h1 'quit' ""
+
+
+
+echo "*** done"
+rm -f $seq.full
+status=0
diff --git a/tests/qemu-iotests/146.out b/tests/qemu-iotests/146.out
new file mode 100644
index 0000000..ddcfeb6
--- /dev/null
+++ b/tests/qemu-iotests/146.out
@@ -0,0 +1,38 @@
+QA output created by 146
+
+=== Testing VPC Autodetect ===
+
+QEMU X.Y.Z monitor - type 'help' for more information
+(qemu) q[K[Dqe[K[D[Dqem[K[D[D[Dqemu[K[D[D[D[Dqemu-[K[D[D[D[D[Dqemu-i[K[D[D[D[D[D[Dqemu-io[K[D[D[D[D[D[D[Dqemu-io [K[D[D[D[D[D[D[D[Dqemu-io d[K[D[D[D[D[D[D[D[D[Dqemu-io di[K[D[D[D[D[D[D[D[D[D[Dqemu-io dis[K[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk[K[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk [K[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "[K[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "m[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "ma[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map"[K
+[                       0]  266334240/ 266334240 sectors not allocated at offset 0 bytes (0)
+
+=== Testing VPC with current_size force ===
+
+QEMU X.Y.Z monitor - type 'help' for more information
+(qemu) q[K[Dqe[K[D[Dqem[K[D[D[Dqemu[K[D[D[D[Dqemu-[K[D[D[D[D[Dqemu-i[K[D[D[D[D[D[Dqemu-io[K[D[D[D[D[D[D[Dqemu-io [K[D[D[D[D[D[D[D[Dqemu-io d[K[D[D[D[D[D[D[D[D[Dqemu-io di[K[D[D[D[D[D[D[D[D[D[Dqemu-io dis[K[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk[K[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk [K[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "[K[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "m[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "ma[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map"[K
+[                       0]  266338304/ 266338304 sectors not allocated at offset 0 bytes (0)
+
+=== Testing VPC with chs force ===
+
+QEMU X.Y.Z monitor - type 'help' for more information
+(qemu) q[K[Dqe[K[D[Dqem[K[D[D[Dqemu[K[D[D[D[Dqemu-[K[D[D[D[D[Dqemu-i[K[D[D[D[D[D[Dqemu-io[K[D[D[D[D[D[D[Dqemu-io [K[D[D[D[D[D[D[D[Dqemu-io d[K[D[D[D[D[D[D[D[D[Dqemu-io di[K[D[D[D[D[D[D[D[D[D[Dqemu-io dis[K[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk[K[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk [K[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "[K[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "m[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "ma[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map"[K
+[                       0]  266334240/ 266334240 sectors not allocated at offset 0 bytes (0)
+
+=== Testing Hyper-V Autodetect ===
+
+QEMU X.Y.Z monitor - type 'help' for more information
+(qemu) q[K[Dqe[K[D[Dqem[K[D[D[Dqemu[K[D[D[D[Dqemu-[K[D[D[D[D[Dqemu-i[K[D[D[D[D[D[Dqemu-io[K[D[D[D[D[D[D[Dqemu-io [K[D[D[D[D[D[D[D[Dqemu-io d[K[D[D[D[D[D[D[D[D[Dqemu-io di[K[D[D[D[D[D[D[D[D[D[Dqemu-io dis[K[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk[K[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk [K[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "[K[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "m[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "ma[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map"[K
+[                       0]  266338304/ 266338304 sectors not allocated at offset 0 bytes (0)
+
+=== Testing Hyper-V with current_size force ===
+
+QEMU X.Y.Z monitor - type 'help' for more information
+(qemu) q[K[Dqe[K[D[Dqem[K[D[D[Dqemu[K[D[D[D[Dqemu-[K[D[D[D[D[Dqemu-i[K[D[D[D[D[D[Dqemu-io[K[D[D[D[D[D[D[Dqemu-io [K[D[D[D[D[D[D[D[Dqemu-io d[K[D[D[D[D[D[D[D[D[Dqemu-io di[K[D[D[D[D[D[D[D[D[D[Dqemu-io dis[K[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk[K[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk [K[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "[K[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "m[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "ma[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map"[K
+[                       0]  266338304/ 266338304 sectors not allocated at offset 0 bytes (0)
+
+=== Testing Hyper-V with chs force ===
+
+QEMU X.Y.Z monitor - type 'help' for more information
+(qemu) q[K[Dqe[K[D[Dqem[K[D[D[Dqemu[K[D[D[D[Dqemu-[K[D[D[D[D[Dqemu-i[K[D[D[D[D[D[Dqemu-io[K[D[D[D[D[D[D[Dqemu-io [K[D[D[D[D[D[D[D[Dqemu-io d[K[D[D[D[D[D[D[D[D[Dqemu-io di[K[D[D[D[D[D[D[D[D[D[Dqemu-io dis[K[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk[K[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk [K[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "[K[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "m[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "ma[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map[K[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[D[Dqemu-io disk "map"[K
+[                       0]  266334240/ 266334240 sectors not allocated at offset 0 bytes (0)
+*** done
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
index 47fd40c..1211149 100644
--- a/tests/qemu-iotests/group
+++ b/tests/qemu-iotests/group
@@ -148,3 +148,4 @@
 143 auto quick
 144 rw auto quick
 145 auto quick
+146 auto quick